import UIKit

extension UIView {
    func addBackgroundAcceuil(imageName: String = "fond_acceuil.png", contentMode: UIView.ContentMode = .scaleToFill) {
        // setup the UIImageView
        let backgroundImageView = UIImageView(frame: UIScreen.main.bounds)
        backgroundImageView.image = UIImage(named: imageName)
        backgroundImageView.contentMode = contentMode
        backgroundImageView.translatesAutoresizingMaskIntoConstraints = false

        addSubview(backgroundImageView)
        sendSubviewToBack(backgroundImageView)

        // adding NSLayoutConstraints
        let leadingConstraint = NSLayoutConstraint(item: backgroundImageView, attribute: .leading, relatedBy: .equal, toItem: self, attribute: .leading, multiplier: 1.0, constant: 0.0)
        let trailingConstraint = NSLayoutConstraint(item: backgroundImageView, attribute: .trailing, relatedBy: .equal, toItem: self, attribute: .trailing, multiplier: 1.0, constant: 0.0)
        let topConstraint = NSLayoutConstraint(item: backgroundImageView, attribute: .top, relatedBy: .equal, toItem: self, attribute: .top, multiplier: 1.0, constant: 0.0)
        let bottomConstraint = NSLayoutConstraint(item: backgroundImageView, attribute: .bottom, relatedBy: .equal, toItem: self, attribute: .bottom, multiplier: 1.0, constant: 0.0)

        NSLayoutConstraint.activate([leadingConstraint, trailingConstraint, topConstraint, bottomConstraint])
    }
}

class ViewController: UIViewController, UIPickerViewDataSource, UIPickerViewDelegate {

    
    @IBAction func ranking(_ sender: Any) {
    }
    
    @IBAction func myScore(_ sender: Any) {
    }
    @IBOutlet weak var classement: UIButton!
    @IBOutlet weak var pseudoinput: UITextField!
    @IBOutlet weak var choixTheme: UIPickerView!
    @IBOutlet weak var choixNiv: UISegmentedControl!

    
    @IBAction func ank(_ sender: Any) {
        
    }
    var wordToGuess : String = ""
    let pickerData = ["Animals", "Sports", "Food", "Cities", "Colors"]
    var gameEngine : GameEngine = GameEngine()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        view.addBackgroundAcceuil()
        choixTheme.dataSource = self
        choixTheme.delegate = self
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?){
        if segue.identifier == "DeAccueilAJeu" {
            let destinationVC = segue.destination as! GameViewController
            destinationVC.gameEngine = gameEngine
            
        }
    }

    @IBAction func LancerPartie(_ sender: Any) {
        guard let pseudo = pseudoinput.text else {
            return
        }
        
        let niveauIndex = choixNiv.selectedSegmentIndex
        let niveau = choixNiv.titleForSegment(at: niveauIndex)
        
        let themeIndex = choixTheme.selectedRow(inComponent: 0)
        let theme = pickerData[themeIndex]
        
        // Utilisez les valeurs récupérées comme vous le souhaitez
        print("Pseudo: \(pseudo)")
        print("Niveau: \(niveau ?? "")")
        print("Thème: \(theme)")
        
        // Ajoutez votre code supplémentaire ici
        let difficulty = niveau ?? ""

        gameEngine.WordToGuess(theme: theme, difficulty: difficulty)
        print("Mot à deviner: \(wordToGuess)")
    }
    
    // MARK: - UIPickerViewDataSource
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        return pickerData.count
    }
    
    // MARK: - UIPickerViewDelegate
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        return pickerData[row]
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        // Code à exécuter lorsque l'utilisateur sélectionne une valeur dans le pickerView.
    }
}
